<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="carbon" uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.governance.lcm.ui.clients.LifeCycleManagementServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<link type="text/css" rel="stylesheet" href="css/menu.css"/>
<link type="text/css" rel="stylesheet" href="css/style.css"/>

<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<script type="text/javascript" src="js/lcm.js"></script>
<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String[] temp = null;
    try{
        LifeCycleManagementServiceClient client = new LifeCycleManagementServiceClient(cookie, config, session);
        temp = client.getLifeCycleList(request);
    } catch (Exception e){
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.governance.lcm.ui.i18n.Resources">
<carbon:breadcrumb
        label="governance.lcm.menu"
        resourceBundle="org.wso2.carbon.governance.lcm.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<div id="middle">

      <h2>
         <fmt:message key="governance.lcm.menu"/>
      </h2>
      <div id="workArea">
<%
    if (temp == null || temp.length == 0 || temp[0] == null) {
%>
        <div id="noLCDiv">
            <fmt:message
                    key="no.lifecycles.are.currently.defined.click.add.lifecycles.to.create.a.new.lifecycle"></fmt:message>
        </div>
<%
    } else {
%>
          <table class="styledLeft" cellspacing="1" id="lcmTable">
              <thead>
                  <tr>
                      <th>
                          <fmt:message key="name"/>
                      </th>
                      <th>
                          <fmt:message key="actions"/>
                      </th>
                  </tr>
              </thead>
              <tbody>

            <%
                for(String next:temp){
            %>
                  <tr>
                      <td>
                          <%=next%>
                      </td>
                                      <td>
                              <a href="#" onclick="editLC('<%=next%>')" class="icon-link" style="background-image:url(../admin/images/edit.gif);"><fmt:message key="edit"/></a>
				<a href="#" onclick="deleteLC('<%=next%>')" class="icon-link" style="background-image:url(../admin/images/delete.gif);"><fmt:message key="delete"/></a>
                                   </td>
                                      
                  </tr>
          <%
              }
          %>
              </tbody>
          </table>
<%
    }
%>
          <script type="text/javascript">
              alternateTableRows('lcmTable', 'tableEvenRow', 'tableOddRow');
          </script>

          <div style="height:25px;">
              <a class="icon-link" style="background-image: url(../admin/images/add.gif);" href="source_lcm.jsp"><fmt:message key="add.lifecycle"/></a>
          </div>

      </div>


  </div>
</fmt:bundle>