<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="carbon" uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.governance.lcm.ui.clients.LifeCycleManagementServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<link type="text/css" rel="stylesheet" href="css/menu.css"/>
<link type="text/css" rel="stylesheet" href="css/style.css"/>

<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<script type="text/javascript" src="js/lcm.js"></script>
<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String temp = "";
    boolean isNew = true;
    try{
        LifeCycleManagementServiceClient client = new LifeCycleManagementServiceClient(cookie, config, session);
        if (request.getParameter("lifecycleName") != null) {
            temp = client.getLifeCycle(request);
            isNew = false;
        } else {
            temp = "<!-- Following is a sample Life Cycle. Please edit it according to your requirements -->\n" +
            "<aspect name=\"SampleLifeCycle\" class=\"org.wso2.carbon.governance.registry.extensions.aspects.ChecklistLifeCycle\">\n" +
            "\t<configuration type=\"literal\">\n" +
            "\t\t<lifecycle>\n" +
            "\t\t\t<state name=\"Initialize\">\n" +
            "\t\t\t\t<checkitem>Requirements Gathered</checkitem>\n" +
            "\t\t\t\t<checkitem>Architecture Finalized</checkitem>\n" +
            "\t\t\t\t<checkitem>High Level Design Completed</checkitem>\n" +
            "\t\t\t</state>\n" +
            "\t\t\t<state name=\"Designed\">\n" +
            "\t\t\t\t<checkitem>Code Completed</checkitem>\n" +
            "\t\t\t\t<checkitem>WSDL, Schema Created</checkitem>\n" +
            "\t\t\t\t<checkitem>QoS Created</checkitem>\n" +
            "\t\t\t</state>\n" +
            "\t\t\t<state name=\"Created\">\n" +
            "\t\t\t\t<checkitem>Effective Inspection Completed</checkitem>\n" +
            "\t\t\t\t<checkitem>Test Cases Passed</checkitem>\n" +
            "\t\t\t\t<checkitem>Smoke Test Passed</checkitem>\n" +
            "\t\t\t</state>\n" +
            "\t\t\t<state name=\"Tested\">\n" +
            "\t\t\t\t<checkitem>Service Configuration</checkitem>\n" +
            "\t\t\t</state>    \n" +
            "\t\t\t<state name=\"Deployed\">\n" +
            "\t\t\t\t<checkitem>Service Configuration</checkitem>\n" +
            "\t\t\t</state>\n" +
            "\t\t\t<state name=\"Deprecated\">\n" +
            "\t\t\t</state>\n" +
            "\t\t</lifecycle>\n" +
            "\t</configuration>\n" +
            "</aspect>";
        }
    } catch (Exception e){
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.governance.lcm.ui.i18n.Resources">
<carbon:breadcrumb
        label="life.cycle.source"
        resourceBundle="org.wso2.carbon.governance.lcm.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>
<script type="text/javascript">

    function cancelSequence() {
        document.location.href = "lcm.jsp?region=region3&item=governance_lcm_menu";
    }

</script>
<div id="middle">
    <h2><fmt:message key="life.cycle.source"/></h2>
    <div id="workArea">
        <form id="life.cycle.source.form" method="post" action="save_lcm.jsp">
            <table class="styledLeft" cellspacing="0" cellpadding="0">
                <thead>
                <tr>
                    <th>
                        <span style="float: left; position: relative; margin-top: 2px;"><fmt:message key="life.cycle"/></span>
                    </th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td>
                        <textarea id="payload" style="border: 0px solid rgb(204, 204, 204); width: 99%; height: 275px; margin-top: 5px;" name="payload" rows="30"><%=temp%></textarea>
                    </td>
                </tr>
                <tr>
                    <td class="buttonRow">
                        <input class="button" type="button" onclick="saveLC('<%=request.getParameter("lifecycleName")%>', '<%=Boolean.toString(isNew)%>')" value="<fmt:message key="save"/>"/>
                        <input class="button" type="button" value="<fmt:message key="cancel"/>" onclick="javascript: cancelSequence(); return false;"/>
                    </td>
                </tr>
                </tbody>
            </table>
        </form>
    </div>
</div>
</fmt:bundle>
