function addAspect() {

	var path = document.getElementById('aspectResourcePath').value;
	var aspect = document.getElementById('aspect').value;

	new Ajax.Request(
			'../lifecycles/add_aspect_ajaxprocessor.jsp',
			{
				method : 'post',
				parameters : {
					path : path,
					aspect : aspect
				},

				onSuccess : function() {

					refreshLifecyclesSection(path);
					refreshPropertiesSection(path);
					alternateTableRows('myTable', 'tableEvenRow', 'tableOddRow');
				},
				onFailure : function(transport) {
					showRegistryError('Failed to add aspect: ' + transport.responseText);
				}
			});
}

function removeAspect() {
    var path = document.getElementById('resPath').value;
	var aspect = document.getElementById('aspectName').value;

    CARBON.showConfirmationDialog("Are you sure you want to delete <strong>'" + aspect + "'</strong> permanently?", function() {
        new Ajax.Request('../lifecycles/remove_aspect_ajaxprocessor.jsp',
        {
            method : 'post',
            parameters : {
                path : path,
                aspect : aspect
            },
            onSuccess: function(transport) {
              refreshLifecyclesSection(path);
            },
            onFailure: function(transport) {
                CARBON.showErrorDialog(transport.responseText);
            }
        });
    }, null);
}

var lifecyleOperationStarted = false;
function invokeAspect(path, aspect, action) {
    if (lifecyleOperationStarted) {
        CARBON.showWarningDialog("A lifecycle operation is currently in progress. Please try again later.");
        return;
    }
    lifecyleOperationStarted = true;
	var items = [];
	if (document.getElementById('itemcount') != null) {
		var itemcount = document.getElementById('itemcount').value;
		for ( var i = 0; i < itemcount; i++) {
			if (document.getElementById('option' + i.toString()).checked) {
				items[i] = 'true';
			} else {
				items[i] = 'false';
			}
		}
	}
    new Ajax.Request('../resources/session-validate.jsp',
    {
        method:'post',
        asynchronous:false,
        onSuccess: function(transport) {
            var returnValue = transport.responseText;
            if(returnValue.search(/----timeout----/) == -1){
                lifecyleOperationStarted = false;
                CARBON.showErrorDialog("Session timed out. Please login again",function(){
                    location.href="../admin/logout_action.jsp";
                    return;
                });
            } else {
                new Ajax.Request('../lifecycles/invoke_aspect_ajaxprocessor.jsp',
                {
                    method : 'post',
                    parameters : {
                        path : path,
                        aspect : aspect,
                        action : action,
                        items : items
                    },

                    onSuccess : function() {
                        refreshLifecyclesSection(path, action);

                        // refreshPropertiesSection(path);
                        // alternateTableRows('myTable', 'tableEvenRow',
                        // 'tableOddRow');
                        if (action.toUpperCase() == "PROMOTE"
                                || action.toUpperCase() == "DEMOTE") {
                            var message = "Successfully " + action + "d!";
                            CARBON.showInfoDialog(message);
                        }

                    },

                    onFailure : function(transport) {
                        showRegistryError('Failed to invoke aspect: ' + transport.responseText);
                    }
                });
            }
        },
        onFailure: function(transport) {

        }
    });
    lifecyleOperationStarted = false;
}

function refreshLifecyclesSection(path) {

	new Ajax.Updater(
			'lifecyclesDiv',
			'../lifecycles/lifecycles_ajaxprocessor.jsp',
			{
				method : 'post',
				parameters : {
					path : path
				},
				evalScripts : true,

				onSuccess : function(transport) {
					var newPath = transport.responseText;

					newPath = removeCarriageReturns(newPath);

					if (newPath.indexOf("/") > 0) {
						refreshPropertiesSection(path);
					} else {
						newPath = newPath.substring(0, newPath.indexOf("<"));
						refreshPropertiesSection(newPath);

					}

					alternateTableRows('myTable', 'tableEvenRow', 'tableOddRow');

				},

				onFailure : function(transport) {
					showRegistryError(transport.responseText);
			}

			});

}

function refreshPropertiesSection(path) {
	if (document.getElementById('propertiesDiv') != null) {
		new Ajax.Updater('propertiesDiv',
				'../properties/properties-main-ajaxprocessor.jsp', {
					method : 'post',
					parameters : {
						path : path
					}
				});
	}
}

function removeCarriageReturns(newPath) {
	return newPath.replace('\n', '', 'g');
}

