<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>

<%@ page import="org.wso2.carbon.registry.common.utils.RegistryUtil"%>
<%@ page
	import="org.wso2.carbon.governance.mgt.ui.custom.lifecycles.checklist.util.xsd.LifecycleActions"%>
<%@ page
	import="org.wso2.carbon.governance.mgt.ui.custom.lifecycles.checklist.beans.xsd.LifecycleBean"%>
<%@ page
	import="org.wso2.carbon.governance.ui.custom.lifecycles.checklist.clients.LifecycleServiceClient"%>
<%@ page
	import="org.wso2.carbon.governance.mgt.ui.custom.lifecycles.checklist.util.xsd.Property"%>
<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Collections"%>
<%@ page import="org.wso2.carbon.registry.core.RegistryConstants" %>


<%
    class CheckListItem implements Comparable{
        String lifeCycleStatus;
        String name;
        String value;
        String order;
        String propertyName;

        public String getPropertyName() {
            return propertyName;
        }

        public void setPropertyName(String propertyName) {
            this.propertyName = propertyName;
        }

        public String getLifeCycleStatus() {
            return lifeCycleStatus;
        }

        public void setLifeCycleStatus(String lifeCycleStatus) {
            this.lifeCycleStatus = lifeCycleStatus;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getValue() {
            return value;
        }

        public void setValue(String value) {
            this.value = value;
        }

        public String getOrder() {
            return order;
        }

        public void setOrder(String order) {
            this.order = order;
        }

        public CheckListItem(String lifeCycleStatus, String name, String value, String order) {
            this.lifeCycleStatus = lifeCycleStatus;
            this.name = name;
            this.value = value;
            this.order = order;
        }

        public CheckListItem() {

        }

        public boolean matchLifeCycleStatus(String status, boolean ignoreCase) {
            if ((lifeCycleStatus == null) || (status == null)) {
                return false;
            }

            if (ignoreCase)
                return lifeCycleStatus.equalsIgnoreCase(status);
            else
                return lifeCycleStatus.equals(status);
        }

        public boolean matchLifeCycleStatus(String status) {
            return matchLifeCycleStatus(status, true);
        }

        public int compareTo(Object anotherItem) {
            if (!(anotherItem instanceof CheckListItem))
                return 0;

            try {
                CheckListItem item = (CheckListItem)anotherItem;
                int otherItemOrder = Integer.parseInt(item.getOrder());
                int itemOrder = Integer.parseInt(order);

                return itemOrder - otherItemOrder;
            }
            catch (Exception e) {
                /* suppressing any parsing errors, since order is not "that" important to consider. */
            }
            return 0;
        }
    };
    String path = RegistryUtil.getPath(request);

    // lifecycle portlet is not displayed for root or items under system. 
    if (path.equals(RegistryConstants.ROOT_PATH) || path.startsWith("/system"))
        return;

    LifecycleBean bean;

    try {
        LifecycleServiceClient lifecycleServiceClient = new LifecycleServiceClient(config, session);
        bean = lifecycleServiceClient.getLifecycleBean(path);
    } catch (Exception e) {
        bean = null;
    }

    if (bean != null) {
		if (bean.getLink() || bean.getMounted()) {
        	return;
    	}
        Property[] lifecycleProps = bean.getLifecycleProperties();
        if (lifecycleProps == null) {
            lifecycleProps = new Property[0];
        }

//    List<String> lifecycleProps = propertiesBean.getLifecycleProperties();
//    Properties props = propertiesBean.getProperties();
%>
<script type="text/javascript" src="../lifecycles/js/lifecycles.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>

<fmt:bundle
	basename="org.wso2.carbon.governance.ui.custom.lifecycles.checklist.i18n.Resources">
	<carbon:jsi18n
		resourceBundle="org.wso2.carbon.governance.ui.custom.lifecycles.checklist.i18n.JSResources"
		request="<%=request%>" />

	<div class="box1-head">
	<table cellspacing="0" cellpadding="0" border="0" style="width: 100%">
		<tr>

			<td valign="top">
			<h2 class="sub-headding-lifecycle"><fmt:message key="lifecycle" /></h2>
			</td>
			<td align="right" valign="top" class="expanIconCell"><a
				onclick="showHideCommon('lifecycleIconExpanded');showHideCommon('lifecycleIconMinimized');showHideCommon('lifecycleExpanded');">
			<% if (lifecycleProps.length == 0) { %> <img
				src="images/icon-expanded.gif" border="0" align="top"
				id="lifecycleIconExpanded" style="display: none;" /> <img
				src="images/icon-minimized.gif" border="0" align="top"
				id="lifecycleIconMinimized" /> <% } else { %> <img
				src="images/icon-expanded.gif" border="0" align="top"
				id="lifecycleIconExpanded" /> <img src="images/icon-minimized.gif"
				border="0" align="top" id="lifecycleIconMinimized"
				style="display: none;" /> <% } %> </a></td>

		</tr>
	</table>
	</div>

	<% if (lifecycleProps.length == 0) { %>
	<div class="box1-mid" id="lifecycleExpanded" style="display: none;" />
	<% } else { %>
	<div class="box1-mid" id="lifecycleExpanded">
	<% } %>
	<div id="lifecycleSum"></div>
	<!-- Life cycle add box --> <% if (bean.getLoggedIn() && !bean.getVersionView() && bean.getPutAllowed() &&
            lifecycleProps.length == 0 && bean.getAspectsToAdd() != null && bean.getAspectsToAdd().length != 0) { %>
	<div class="icon-link-ouside"><a class="icon-link"
		style="background-image: url(../admin/images/add.gif);"
		href="javascript:void(0)"
		onclick="javascript:showHideCommon('add-lifecycle-div');if($('add-lifecycle-div').style.display!='none')$('aspect').focus();">
	<fmt:message key="add.lifecycle" /></a></div>
	<div id="add-lifecycle-div"
		style="display: none; padding-bottom: 10px;">
    <form>
    <table class="styledLeft">
		<thead>
			<tr>
				<th><fmt:message key="enable.lifecycle" /></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td><input type="hidden" id="aspectResourcePath"
					name="resourcePath" value="<%=bean.getPathWithVersion()%>" /> <select
					id="aspect" name="aspect" style="width: 130px">
					<%
                                    String[] aspectsToAdd = bean.getAspectsToAdd();
                                    if (aspectsToAdd == null) aspectsToAdd = new String[0];
                                    for (int aspIndex = 0; aspIndex < aspectsToAdd.length; aspIndex++) {
                                %>
					<option value="<%=aspectsToAdd[aspIndex]%>"><%=aspectsToAdd[aspIndex]%>
					</option>
					<%
                                    }

                                %>
				</select></td>
			</tr>
			<tr>
				<td class="buttonRow"><input type="button" class="button"
					value="<fmt:message key="add"/>" onclick="addAspect();" /> <input
					type="button" class="button" value="<fmt:message key="cancel"/>"
					onclick="showHideCommon('add-lifecycle-div');" /></td>
			</tr>
		</tbody>
	</table>
    </form>

	<!-- Life cycle add box ends --></div>
	<div id="lifecyclesSummary" class="summeryStyle"><fmt:message
		key="no.lifecycles" /></div>

	<%
            } else if (bean.getLoggedIn() && bean.getPutAllowed() &&
                    lifecycleProps.length == 0) {
    %><div id="lifecyclesSummary" class="summeryStyle"><fmt:message
		key="no.lifecycles" /></div><%
            }
            if (lifecycleProps.length > 0) {
        %> <!-- START life cycle listing box -->
	<div id="aspectList">
    <table class="styledLeft">
    <tbody>
        <tr>
            <td>
            <%

                    String lifeCycleLongName = "";
                    String lifeCycleState = "";
                    for (Property property : lifecycleProps) {
                        String propName = property.getKey();
                        String[] propValues = property.getValues();
                        if (propValues != null && propValues.length != 0) {
                            String value = propValues[0];
                            if (propName.equals("registry.LC.name")) {
                                lifeCycleLongName = value;
                            }
                        }
                    }
                

                    for (Property property : lifecycleProps) {
                        String propName = property.getKey();
                        String[] propValues = property.getValues();
                        if (propValues != null && propValues.length != 0) {
                            String value = propValues[0];
                            String prefix = "registry.lifecycle.";
                            String suffix = ".state";
                            if (propName.startsWith(prefix) && propName.endsWith(suffix)) {
                                lifeCycleState = value;
                                // Grab the text in between...
                                String lifecycleName = propName.substring(prefix.length(),
                                        propName.length() - suffix.length());

                                if (lifeCycleLongName.equals(""))
                                    lifeCycleLongName = lifecycleName;
                %>

			<%
                            }
                        }
                    }

                            String lifecycleName = "";
                            LifecycleActions[] availableActions = bean.getAvailableActions();
                            if (availableActions != null && availableActions.length > 0) {
                                LifecycleActions lifecycleActions = availableActions[0];
                                if (lifecycleActions != null) {
                                    lifecycleName = lifecycleActions.getLifecycle();
                                }
                            }

                            ArrayList<CheckListItem> checkListItems = new ArrayList<CheckListItem>();
                            for (Property property : lifecycleProps) {
                                String propName = property.getKey();
                                String[] propValues = property.getValues();
                                if (propValues != null && propValues.length > 2) {
                                    CheckListItem checkListItem = new CheckListItem();

                                    for (String param: propValues) {
                                        if ((checkListItem.getLifeCycleStatus() == null) && (param.startsWith("status:"))) {
                                            checkListItem.setLifeCycleStatus(param.substring(7));
                                        }
                                        if ((checkListItem.getName() == null) && (param.startsWith("name:"))) {
                                            checkListItem.setName(param.substring(5));
                                        }
                                        if ((checkListItem.getValue() == null) && (param.startsWith("value:"))) {
                                            checkListItem.setValue(param.substring(6));
                                        }
                                        if ((checkListItem.getOrder() == null) && (param.startsWith("order:"))) {
                                            checkListItem.setOrder(param.substring(6));
                                        }
                                    }

                                    String prefix = "registry.custom_lifecycle.checklist.";
                                    String suffix = ".item";
                                    if ((propName.startsWith(prefix) && propName.endsWith(suffix))
                                            && checkListItem.matchLifeCycleStatus(lifeCycleState)) {
                                        checkListItems.add(checkListItem);
                                    }
                                }
                            }

                            Collections.sort(checkListItems);
            if (!bean.getVersionView()) {
            %>

            <div style="height:0px;">
                <input type="hidden" id="resPath" name="resPath" value="<%=bean.getPathWithVersion()%>" />
                <input type="hidden" id="aspectName" name="aspectName" value="<%=lifecycleName%>" />
                <a class="icon-link" style="float:right;background-image:url(../admin/images/delete.gif);"
                   onclick="removeAspect();">
                    <fmt:message key="delete"/>
                </a>
             </div>
            <% } %>
             <div>
                 <table cellpadding="0" cellspacing="5" border="0">
                     <tbody>
                         <tr>
                             <th><fmt:message key="lifecycle.name" />:</th>
                             <td style="border:0"><%=lifeCycleLongName%></td>
                         </tr>
                         <tr>
                             <th><fmt:message key="lifecycle.state" />:</th>
                             <td style="border:0"><%=lifeCycleState%></td>
                         </tr>            <%
                         if (checkListItems.size() > 0) {
                                 %>
                         <tr>
                             <th><fmt:message key="checklist.header" />:</th>
                             <td style="border:0"></td>
                         </tr>
                         <% } %>
                     </tbody>
                 </table>
             </div>

            <div>
                <table  style="margin-bottom: 15px;" class="styledLeft" id="myTable">
                <tbody>

                    <%

                            int index = 0;
                            for (CheckListItem item: checkListItems) {
                                if ((index % 2) == 0) { %>
                    <tr class="tableEvenRow">
                        <%      } else { %>

                    <tr class="tableOddRow">
                        <%      } %>
                        <td>
                        <%
                                        if (item.getValue().equalsIgnoreCase("true")) {
                                %> <input type="checkbox" id="option<%=index%>"
                            value="true" checked
                            <% if (!bean.getPutAllowed() || !bean.getLoggedIn() || bean.getVersionView()) {%>
                            disabled="disabled" <%}%>
                            onclick="invokeAspect('<%=bean.getPathWithVersion()%>', '<%=lifecycleName%>', 'itemClick')">
                        <b><%=item.getName()%></b><br>
                        <%      }
                                        else {
                                %> <input type="checkbox" id="option<%=index%>"
                            value="true"
                            <% if (!bean.getPutAllowed() || !bean.getLoggedIn() || bean.getVersionView()) {%>
                            disabled="disabled" <%}%>
                            onclick="invokeAspect('<%=bean.getPathWithVersion()%>', '<%=lifecycleName%>', 'itemClick')">
                        <b><%=item.getName()%></b><br>
                        <%      } %>
                        </td>
                    </tr>
                    <%
                                index++;
                            }
                        %>
                    <input type="hidden" id="itemcount" value="<%=index%>">
                </tbody>
            </table>
          </div>
          </td>
       </tr>
        <%
        if (availableActions != null && availableActions.length > 0) { %>

	    <tr>
				<td class="buttonRow">
				<div id="lifeCycleButtons">
				<%
                        LifecycleActions lifecycleActions = availableActions[0];
                        if (lifecycleActions != null) {
                            String lifecycle = lifecycleActions.getLifecycle();
                
                            String[] actions = lifecycleActions.getActions();
                            if (actions == null) actions = new String[0];
                            for (String action : actions) {   
                                if (bean.getLoggedIn() && !bean.getVersionView() && bean.getPutAllowed()) { %>
				<input class="button" type="button"
					value="<fmt:message key="action.lifecycle"><fmt:param value="<%=action%>"/></fmt:message>"
					onclick="invokeAspect('<%=bean.getPathWithVersion()%>', '<%=lifecycle%>', '<%=action%>')" />
				<%              }
                            }
                        } %>
				</div>
				</td>
			</tr><%
        } %>
		</tbody>
	</table>
	</div>
	<!-- END lifecycle listing box -->
    <% } %>
	</div>
</fmt:bundle>
<% }

%>

